From e8a7d54d284d0039ec3904e667b3c02f2930af6b Mon Sep 17 00:00:00 2001
From: William Brown <firstyear@redhat.com>
Date: Mon, 10 Jul 2017 14:51:49 +1000
Subject: [PATCH] Ticket 49316 - Fix clock unsafety in DS

Bug Description:  DS is heavily reliant on correct working time
for a variety of aspects. In almost every aspect of the server
we found a way to misuse time somehow. From timeouts only
checking second boundaries which would lead to timeouts of
less that 1 second in some cases, to enforcing 32bit times on
64bit platforms, confusion of absolute utc times and relative
offsets, incorrect time types (not time_t), wrapping thread
safe functions in mutexs causing import perf issues, and finally,
using not-threadsafe polling function to update an int
representing the current time, which may never be flushed
to the cache, nor other threads reading it.

tl;dr - what didn't we do wrong with time?

Fix Description:  This fix has to cover a lot of ground:

* make clock_gettime a requirement of the server
* deprecate broken api's to create noise when people use them
* remove the clock thread
* replace access to clocks with clock_gettime
* add a clock_monotonic interface for timeouts which is
  not affected by admin clock changes
* update search/add etc to use timespec timeouts rather
  than time_t
* replace calls to the broken "current_time()" function
  with a properly labeled utc or rel time function
* fix checkpoint thread to run compact indepedent to
  checkpoints
* remove incorrectly defined gmtime_r functions
* remove incorrect documentation about atomicity of statics
  in the server
* fix locations that used time as an int to time_t (2038 work)
* deprecate long and long long value parser for time replacing
  with time_t to prevent 2038 issues

https://pagure.io/389-ds-base/issue/49316

Author: wibrown

Review by: ???
---
 configure.ac                                       |   5 +-
 .../plugins/acct_usability/acct_usability.c        |   2 +-
 ldap/servers/plugins/acctpolicy/acct_plugin.c      |   4 +-
 ldap/servers/plugins/acctpolicy/acct_util.c        |   6 +-
 ldap/servers/plugins/automember/automember.c       |   4 +-
 ldap/servers/plugins/chainingdb/cb.h               |   3 +-
 ldap/servers/plugins/chainingdb/cb_add.c           |   5 +-
 ldap/servers/plugins/chainingdb/cb_compare.c       |   7 +-
 .../servers/plugins/chainingdb/cb_conn_stateless.c |  69 +++----
 ldap/servers/plugins/chainingdb/cb_delete.c        |   5 +-
 ldap/servers/plugins/chainingdb/cb_modify.c        |   5 +-
 ldap/servers/plugins/chainingdb/cb_modrdn.c        |   5 +-
 ldap/servers/plugins/chainingdb/cb_search.c        | 126 ++++++------
 ldap/servers/plugins/dna/dna.c                     |   2 +-
 ldap/servers/plugins/replication/cl5_api.c         |  10 +-
 ldap/servers/plugins/replication/repl5_backoff.c   |   4 +-
 .../servers/plugins/replication/repl5_connection.c |  10 +-
 .../plugins/replication/repl5_inc_protocol.c       |  16 +-
 ldap/servers/plugins/replication/repl5_replica.c   |  19 +-
 ldap/servers/plugins/replication/repl5_ruv.c       |   8 +-
 .../plugins/replication/repl5_tot_protocol.c       |  14 +-
 ldap/servers/plugins/replication/repl_objset.c     |   4 +-
 .../plugins/replication/windows_connection.c       |   2 +-
 .../plugins/replication/windows_inc_protocol.c     |   6 +-
 .../plugins/replication/windows_tot_protocol.c     |   6 +-
 ldap/servers/plugins/retrocl/retrocl_po.c          |   2 +-
 ldap/servers/plugins/retrocl/retrocl_trim.c        |   2 +-
 ldap/servers/plugins/rootdn_access/rootdn_access.c |  14 +-
 ldap/servers/plugins/syntaxes/string.c             |  34 ++--
 ldap/servers/slapd/abandon.c                       |   6 +-
 ldap/servers/slapd/add.c                           |   8 +-
 ldap/servers/slapd/auditlog.c                      |   4 +-
 ldap/servers/slapd/back-ldbm/dblayer.c             | 212 +++++++++++---------
 ldap/servers/slapd/back-ldbm/idl_new.c             |  20 +-
 ldap/servers/slapd/back-ldbm/import-merge.c        |  13 +-
 ldap/servers/slapd/back-ldbm/import-threads.c      |   8 +-
 ldap/servers/slapd/back-ldbm/import.c              |   8 +-
 ldap/servers/slapd/back-ldbm/index.c               |  25 +--
 ldap/servers/slapd/back-ldbm/ldbm_search.c         |  30 ++-
 ldap/servers/slapd/back-ldbm/ldif2ldbm.c           |   2 +-
 ldap/servers/slapd/back-ldbm/proto-back-ldbm.h     |   6 +-
 ldap/servers/slapd/back-ldbm/sort.c                |  12 +-
 ldap/servers/slapd/back-ldbm/vlv.c                 |  10 +-
 ldap/servers/slapd/back-ldbm/vlv_srch.c            |  23 +--
 ldap/servers/slapd/back-ldbm/vlv_srch.h            |   2 +-
 ldap/servers/slapd/connection.c                    |   6 +-
 ldap/servers/slapd/conntable.c                     |   4 +-
 ldap/servers/slapd/csngen.c                        |  31 +--
 ldap/servers/slapd/daemon.c                        |  73 +------
 ldap/servers/slapd/eventq.c                        |  38 ++--
 ldap/servers/slapd/generation.c                    |   4 +-
 ldap/servers/slapd/getfilelist.c                   |   2 +-
 ldap/servers/slapd/libglobs.c                      |  58 +++---
 ldap/servers/slapd/log.c                           |  14 +-
 ldap/servers/slapd/main.c                          |   2 +-
 ldap/servers/slapd/monitor.c                       |   2 +-
 ldap/servers/slapd/operation.c                     |  28 ++-
 ldap/servers/slapd/opshared.c                      |  16 +-
 ldap/servers/slapd/pagedresults.c                  |  20 +-
 ldap/servers/slapd/pblock.c                        |   5 +-
 ldap/servers/slapd/pw.c                            |  50 ++---
 ldap/servers/slapd/pw_mgmt.c                       |   2 +-
 ldap/servers/slapd/pw_retry.c                      |   5 +-
 ldap/servers/slapd/regex.c                         |  48 ++++-
 ldap/servers/slapd/result.c                        |  13 +-
 ldap/servers/slapd/sasl_map.c                      |   4 +-
 ldap/servers/slapd/schema.c                        |   4 +-
 ldap/servers/slapd/slap.h                          |  18 +-
 ldap/servers/slapd/slapi-plugin.h                  | 187 ++++++++++++++++--
 ldap/servers/slapd/slapi-private.h                 |  12 +-
 ldap/servers/slapd/time.c                          | 213 +++++++++++----------
 ldap/servers/slapd/uuid.c                          |   2 +-
 ldap/servers/slapd/value.c                         |  21 +-
 73 files changed, 913 insertions(+), 757 deletions(-)

diff --git a/configure.ac b/configure.ac
index 03c1eea..19986c0 100644
--- a/configure.ac
+++ b/configure.ac
@@ -70,7 +70,10 @@ AC_FUNC_STAT
 AC_FUNC_STRERROR_R
 AC_FUNC_STRFTIME
 AC_FUNC_VPRINTF
-AC_CHECK_FUNCS([clock_gettime endpwent ftruncate getcwd gethostbyname inet_ntoa localtime_r memmove memset mkdir munmap putenv rmdir setrlimit socket strcasecmp strchr strcspn strdup strerror strncasecmp strpbrk strrchr strstr strtol tzset])
+AC_CHECK_FUNCS([endpwent ftruncate getcwd gethostbyname inet_ntoa localtime_r memmove memset mkdir munmap putenv rmdir setrlimit socket strcasecmp strchr strcspn strdup strerror strncasecmp strpbrk strrchr strstr strtol tzset])
+
+# These functions are *required* without option.
+AC_CHECK_FUNCS([clock_gettime], [], AC_MSG_ERROR([unable to locate required symbol clock_gettime]))
 
 # This will detect if we need to add the LIBADD_DL value for us.
 LT_LIB_DLLOAD
diff --git a/ldap/servers/plugins/acct_usability/acct_usability.c b/ldap/servers/plugins/acct_usability/acct_usability.c
index fc8c53a..06d7ea9 100644
--- a/ldap/servers/plugins/acct_usability/acct_usability.c
+++ b/ldap/servers/plugins/acct_usability/acct_usability.c
@@ -197,7 +197,7 @@ static LDAPControl *auc_create_response_ctrl(Slapi_Entry *e)
     Slapi_PWPolicy *pwpolicy = NULL;
     time_t expire_time = (time_t)0;
     time_t unlock_time = (time_t)0;
-    time_t now = slapi_current_time();
+    time_t now = slapi_current_utc_time();
 
     if (!e) {
         slapi_log_err(SLAPI_LOG_PLUGIN, AUC_PLUGIN_SUBSYSTEM,
diff --git a/ldap/servers/plugins/acctpolicy/acct_plugin.c b/ldap/servers/plugins/acctpolicy/acct_plugin.c
index 27c27bc..b24c746 100644
--- a/ldap/servers/plugins/acctpolicy/acct_plugin.c
+++ b/ldap/servers/plugins/acctpolicy/acct_plugin.c
@@ -99,7 +99,7 @@ acct_inact_limit( Slapi_PBlock *pb, const char *dn, Slapi_Entry *target_entry, a
 	}
 
 	last_t = gentimeToEpochtime( lasttimestr );
-	cur_t = time( (time_t*)0 );
+	cur_t = slapi_current_utc_time();
 	lim_t = policy->inactivitylimit;
 
 	/* Finally do the time comparison */
@@ -159,7 +159,7 @@ acct_record_login( const char *dn )
  
 	plugin_id = get_identity();
 
-	timestr = epochtimeToGentime( time( (time_t*)0 ) );
+	timestr = epochtimeToGentime( slapi_current_utc_time() );
 	val.bv_val = timestr;
 	val.bv_len = strlen( val.bv_val );
 
diff --git a/ldap/servers/plugins/acctpolicy/acct_util.c b/ldap/servers/plugins/acctpolicy/acct_util.c
index 35e8b41..0e5ce8e 100644
--- a/ldap/servers/plugins/acctpolicy/acct_util.c
+++ b/ldap/servers/plugins/acctpolicy/acct_util.c
@@ -221,7 +221,7 @@ gentimeToEpochtime( char *gentimestr ) {
 
 	/* Find the local offset from GMT */
 	cur_gm_time = (struct tm*)slapi_ch_calloc( 1, sizeof( struct tm ) );
-	cur_local_epochtime = time( (time_t *)0 );
+	cur_local_epochtime = slapi_current_utc_time();
 	gmtime_r( &cur_local_epochtime, cur_gm_time );
 	cur_gm_epochtime = mktime( cur_gm_time );
 	free( cur_gm_time );
@@ -255,9 +255,9 @@ epochtimeToGentime( time_t epochtime ) {
 	struct tm t;
 
 	gmtime_r( &epochtime, &t );
-	gentimestr = slapi_ch_malloc( 20 );
+	gentimestr = slapi_ch_malloc(SLAPI_TIMESTAMP_BUFSIZE);
 	/* Format is YYYYmmddHHMMSSZ (15+1 chars) */
-	strftime( gentimestr, 16, "%Y%m%d%H%M%SZ", &t );
+	strftime( gentimestr, SLAPI_TIMESTAMP_BUFSIZE, "%Y%m%d%H%M%SZ", &t );
 
 	return( gentimestr );
 }
diff --git a/ldap/servers/plugins/automember/automember.c b/ldap/servers/plugins/automember/automember.c
index a74d48c..67cb8c4 100644
--- a/ldap/servers/plugins/automember/automember.c
+++ b/ldap/servers/plugins/automember/automember.c
@@ -1398,7 +1398,7 @@ automember_update_membership(struct configEntry *config, Slapi_Entry *e, PRFileD
                     vals = slapi_entry_attr_get_charray(e, curr_rule->attr);
                     for (i = 0; vals && vals[i]; ++i) {
                         /* Evaluate the regex. */
-                        if (slapi_re_exec(curr_rule->regex, vals[i], -1) == 1) {
+                        if (slapi_re_exec_nt(curr_rule->regex, vals[i]) == 1) {
                             /* Found a match.  Add to end of the exclusion list
                              * and set last as a hint to ourselves. */
                             slapi_log_err(SLAPI_LOG_PLUGIN, AUTOMEMBER_PLUGIN_SUBSYSTEM,
@@ -1473,7 +1473,7 @@ automember_update_membership(struct configEntry *config, Slapi_Entry *e, PRFileD
                     vals = slapi_entry_attr_get_charray(e, curr_rule->attr);
                     for (i = 0; vals && vals[i]; ++i) {
                         /* Evaluate the regex. */
-                        if (slapi_re_exec(curr_rule->regex, vals[i], -1) == 1) {
+                        if (slapi_re_exec_nt(curr_rule->regex, vals[i]) == 1) {
                             /* Found a match.  Add to the end of the targets list
                              * and set last as a hint to ourselves. */
                             slapi_log_err(SLAPI_LOG_PLUGIN, AUTOMEMBER_PLUGIN_SUBSYSTEM,
diff --git a/ldap/servers/plugins/chainingdb/cb.h b/ldap/servers/plugins/chainingdb/cb.h
index 5fc76df..60a4d83 100644
--- a/ldap/servers/plugins/chainingdb/cb.h
+++ b/ldap/servers/plugins/chainingdb/cb.h
@@ -381,7 +381,7 @@ typedef struct _cb_searchContext {
 #define CB_UPDATE_CONTROLS_ISABANDON 2
 
 
-int cb_get_connection(cb_conn_pool * pool, LDAP ** ld, cb_outgoing_conn ** cnx, struct timeval * tmax, char **errmsg);
+int cb_get_connection(cb_conn_pool * pool, LDAP ** ld, cb_outgoing_conn ** cnx, struct timespec *expire_time, char **errmsg);
 int cb_config(cb_backend_instance * cb, int argc, char ** argv );
 int cb_update_controls( Slapi_PBlock *pb, LDAP * ld, LDAPControl *** controls, int ctrl_flags);
 int cb_is_control_forwardable(cb_backend * cb, char *controloid);
@@ -469,7 +469,6 @@ void cb_update_failed_conn_cpt ( cb_backend_instance *cb ) ;
 void cb_reset_conn_cpt( cb_backend_instance *cb ) ;
 int  cb_check_availability( cb_backend_instance *cb, Slapi_PBlock *pb ) ;
 
-time_t current_time(void);
 char* get_localhost_DNS(void);
 
 /* this function is called when state of a backend changes */
diff --git a/ldap/servers/plugins/chainingdb/cb_add.c b/ldap/servers/plugins/chainingdb/cb_add.c
index 9c772ac..7dc3871 100644
--- a/ldap/servers/plugins/chainingdb/cb_add.c
+++ b/ldap/servers/plugins/chainingdb/cb_add.c
@@ -129,8 +129,9 @@ chaining_back_add ( Slapi_PBlock *pb )
 	}
 
 	/* heart-beat management */
-	if (cb->max_idle_time>0)
-		endtime=current_time() + cb->max_idle_time;
+	if (cb->max_idle_time>0) {
+		endtime=slapi_current_utc_time() + cb->max_idle_time;
+	}
 
 	/* Send LDAP operation to the remote host */
 	rc = ldap_add_ext( ld, dn, mods, ctrls, NULL, &msgid );
diff --git a/ldap/servers/plugins/chainingdb/cb_compare.c b/ldap/servers/plugins/chainingdb/cb_compare.c
index a54225a..a7cfd35 100644
--- a/ldap/servers/plugins/chainingdb/cb_compare.c
+++ b/ldap/servers/plugins/chainingdb/cb_compare.c
@@ -123,10 +123,11 @@ chaining_back_compare ( Slapi_PBlock *pb )
                 	ldap_controls_free(ctrls);
                 return -1;
         }
- 
+
 	/* heart-beat management */
-	if (cb->max_idle_time>0)
-        	endtime=current_time() + cb->max_idle_time;
+	if (cb->max_idle_time>0) {
+			endtime=slapi_current_utc_time() + cb->max_idle_time;
+	}
 
 	/*
 	 * Send LDAP operation to the remote host
diff --git a/ldap/servers/plugins/chainingdb/cb_conn_stateless.c b/ldap/servers/plugins/chainingdb/cb_conn_stateless.c
index 499b3a7..6e54b41 100644
--- a/ldap/servers/plugins/chainingdb/cb_conn_stateless.c
+++ b/ldap/servers/plugins/chainingdb/cb_conn_stateless.c
@@ -130,14 +130,13 @@ int
 cb_get_connection(cb_conn_pool * pool,
                   LDAP ** lld,
                   cb_outgoing_conn ** cc,
-                  struct timeval * maxtime,
+                  struct timespec *expire_time,
                   char **errmsg)
 {
 	int 				rc=LDAP_SUCCESS;          /* optimistic */
 	cb_outgoing_conn	*conn=NULL;
 	cb_outgoing_conn	*connprev=NULL;
 	LDAP				*ld=NULL;
-	time_t				endbefore=0;
 	int 				checktime=0;
 	struct timeval		bind_to, op_to;
 	unsigned int 		maxconcurrency,maxconnections;
@@ -147,6 +146,8 @@ cb_get_connection(cb_conn_pool * pool,
 	char 				*mech = NULL;;
 	static	char		*error1="Can't contact remote server : %s";
 	int					isMultiThread = ENABLE_MULTITHREAD_PER_CONN ; /* by default, we enable multiple operations per connection */
+
+	struct timespec cb_expire_time;
 	
 	/*
 	** return an error if we can't get a connection
@@ -204,23 +205,27 @@ cb_get_connection(cb_conn_pool * pool,
 		return LDAP_CONNECT_ERROR;
 	}
 
-	if (maxtime) {
-		if (maxtime->tv_sec != 0) {
+	if (expire_time) {
+		if (expire_time->tv_sec > 0) {
 			checktime=1;
-        		endbefore = current_time() + maxtime->tv_sec;
+
+			cb_expire_time.tv_sec = expire_time->tv_sec;
+			cb_expire_time.tv_nsec = expire_time->tv_nsec;
 
 			/* make sure bind to <= operation timeout */
-			if ((bind_to.tv_sec==0) || (bind_to.tv_sec > maxtime->tv_sec))
-				bind_to.tv_sec=maxtime->tv_sec;
+			if ((bind_to.tv_sec==0) || (bind_to.tv_sec > expire_time->tv_sec)) {
+				bind_to.tv_sec=expire_time->tv_sec;
+			}
 		}
 	} else {
 		if (op_to.tv_sec != 0) {
 			checktime=1;
-        		endbefore = current_time() + op_to.tv_sec;
+			slapi_timespec_expire_at(op_to.tv_sec, &cb_expire_time);
 
 			/* make sure bind to <= operation timeout */
-			if ((bind_to.tv_sec==0) || (bind_to.tv_sec > op_to.tv_sec))
+			if ((bind_to.tv_sec==0) || (bind_to.tv_sec > op_to.tv_sec)) {
 				bind_to.tv_sec=op_to.tv_sec;
+			}
 		}
 	}
 
@@ -238,31 +243,29 @@ cb_get_connection(cb_conn_pool * pool,
     	slapi_lock_mutex( pool->conn.conn_list_mutex );
 
 	if (cb_debug_on()) {
-  		slapi_log_err(SLAPI_LOG_PLUGIN, CB_PLUGIN_SUBSYSTEM,
-        		"cb_get_connection - server %s conns: %d maxconns: %d\n",
-        		hostname, pool->conn.conn_list_count, maxconnections );
+		slapi_log_err(SLAPI_LOG_PLUGIN, CB_PLUGIN_SUBSYSTEM,
+				"cb_get_connection - server %s conns: %d maxconns: %d\n",
+				hostname, pool->conn.conn_list_count, maxconnections );
 	}
 
 	for (;;) {
 
 		/* time limit mgmt */
-		if (checktime) {
-			if (current_time() > endbefore ) {
-  				slapi_log_err(SLAPI_LOG_PLUGIN, CB_PLUGIN_SUBSYSTEM,
-        				"cb_get_connection - server %s expired.\n", hostname );
-				if ( errmsg ) {
-					*errmsg = PR_smprintf(error1,"timelimit exceeded");
-				}
-				rc=LDAP_TIMELIMIT_EXCEEDED;
-				conn=NULL;
-				ld=NULL;
-                         	goto unlock_and_return;    
+		if (checktime && slapi_timespec_expire_check(&cb_expire_time) == TIMER_EXPIRED) {
+			slapi_log_err(SLAPI_LOG_PLUGIN, CB_PLUGIN_SUBSYSTEM,
+					"cb_get_connection - server %s expired.\n", hostname );
+			if ( errmsg ) {
+				*errmsg = PR_smprintf(error1,"timelimit exceeded");
 			}
+			rc=LDAP_TIMELIMIT_EXCEEDED;
+			conn=NULL;
+			ld=NULL;
+			goto unlock_and_return;
 		}
 
-        	/*
-         	 * First, look for an available, already open/bound connection
-         	 */
+		/*
+		 * First, look for an available, already open/bound connection
+		 */
 
 		if (secure) {
 			for (conn = pool->connarray[PR_ThreadSelf()]; conn != NULL; conn = conn->next) {
@@ -456,7 +459,7 @@ cb_get_connection(cb_conn_pool * pool,
 			conn->ld=ld;
 			conn->status=CB_CONNSTATUS_OK;
 			conn->refcount=0;	/* incremented below */
-			conn->opentime=current_time();
+			conn->opentime=slapi_current_utc_time();
 			conn->ThreadId=PR_MyThreadId(); /* store the thread id */
 			conn->next=NULL;
 			if (secure) {
@@ -639,7 +642,7 @@ static void cb_check_for_stale_connections(cb_conn_pool * pool) {
         slapi_lock_mutex(pool->conn.conn_list_mutex);
  
 	if (connlifetime > 0)
-                curtime=current_time();
+                curtime=slapi_current_utc_time();
 	
 	if (pool->secure) {
 		myself = PR_ThreadSelf();
@@ -859,7 +862,7 @@ int cb_ping_farm(cb_backend_instance *cb, cb_outgoing_conn * cnx,time_t end_time
 	if (cnx && (cnx->status != CB_CONNSTATUS_OK ))	/* Known problem */
 		return LDAP_SERVER_DOWN;
 
-	now = current_time();
+	now = slapi_current_utc_time();
 	if (end_time && ((now <= end_time) || (end_time <0))) return LDAP_SUCCESS;
 
 	secure = cb->pool->secure;
@@ -902,7 +905,7 @@ void cb_update_failed_conn_cpt ( cb_backend_instance *cb ) {
 		slapi_unlock_mutex(cb->monitor_availability.cpt_lock);
 		if (cb->monitor_availability.cpt >= CB_NUM_CONN_BEFORE_UNAVAILABILITY ) {
 	       		/* we reach the limit of authorized failed connections => we setup the chaining BE state to unavailable */
-	       		now = current_time();
+	       		now = slapi_current_utc_time();
 			slapi_lock_mutex(cb->monitor_availability.lock_timeLimit);
 	       		       cb->monitor_availability.unavailableTimeLimit = now + CB_UNAVAILABLE_PERIOD ;
 			slapi_unlock_mutex(cb->monitor_availability.lock_timeLimit);
@@ -932,7 +935,7 @@ int cb_check_availability( cb_backend_instance *cb, Slapi_PBlock *pb ) {
 	time_t now ;
 	if ( cb->monitor_availability.farmserver_state == FARMSERVER_UNAVAILABLE ){
 		slapi_lock_mutex(cb->monitor_availability.lock_timeLimit);
-		now = current_time();
+		now = slapi_current_utc_time();
 		if (now >= cb->monitor_availability.unavailableTimeLimit) {
 		    cb->monitor_availability.unavailableTimeLimit = now + CB_INFINITE_TIME ; /* to be sure only one thread can do the test */
 		    slapi_unlock_mutex(cb->monitor_availability.lock_timeLimit);
@@ -946,7 +949,7 @@ int cb_check_availability( cb_backend_instance *cb, Slapi_PBlock *pb ) {
 				"cb_check_availability - ping the farm server and check if it's still unavailable");
 		if (cb_ping_farm(cb, NULL, 0) != LDAP_SUCCESS) { /* farm still unavailable... Just change the timelimit */ 
 		    slapi_lock_mutex(cb->monitor_availability.lock_timeLimit);
-		    now = current_time();
+		    now = slapi_current_utc_time();
 		    cb->monitor_availability.unavailableTimeLimit = now + CB_UNAVAILABLE_PERIOD ;
 		    slapi_unlock_mutex(cb->monitor_availability.lock_timeLimit);		
 		    cb_send_ldap_result( pb, LDAP_OPERATIONS_ERROR, NULL, "FARM SERVER TEMPORARY UNAVAILABLE", 0, NULL) ;
@@ -957,7 +960,7 @@ int cb_check_availability( cb_backend_instance *cb, Slapi_PBlock *pb ) {
 		else {
 		    /* farm is back !*/
 		    slapi_lock_mutex(cb->monitor_availability.lock_timeLimit);
-		    now = current_time();
+		    now = slapi_current_utc_time();
 		    cb->monitor_availability.unavailableTimeLimit = now ; /* the unavailable period is finished */
 		    slapi_unlock_mutex(cb->monitor_availability.lock_timeLimit);	
 		    /* The farmer server state backs to FARMSERVER_AVAILABLE, but this already done in cb_ping_farm, and also the reset of cpt*/
diff --git a/ldap/servers/plugins/chainingdb/cb_delete.c b/ldap/servers/plugins/chainingdb/cb_delete.c
index 7761b94..92333f5 100644
--- a/ldap/servers/plugins/chainingdb/cb_delete.c
+++ b/ldap/servers/plugins/chainingdb/cb_delete.c
@@ -116,8 +116,9 @@ chaining_back_delete ( Slapi_PBlock *pb )
 	}
 
 	/* heart-beat management */
-	if (cb->max_idle_time>0)
-		endtime=current_time() + cb->max_idle_time;
+	if (cb->max_idle_time>0) {
+		endtime=slapi_current_utc_time() + cb->max_idle_time;
+	}
 
 	/*
 	 * Call the backend preoperation plugins
diff --git a/ldap/servers/plugins/chainingdb/cb_modify.c b/ldap/servers/plugins/chainingdb/cb_modify.c
index 411980d..b084bc2 100644
--- a/ldap/servers/plugins/chainingdb/cb_modify.c
+++ b/ldap/servers/plugins/chainingdb/cb_modify.c
@@ -124,8 +124,9 @@ chaining_back_modify ( Slapi_PBlock *pb )
 	cb_remove_illegal_mods(cb,mods);
 
 	/* heart-beat management */
-	if (cb->max_idle_time>0)
-		endtime=current_time() + cb->max_idle_time;
+	if (cb->max_idle_time>0) {
+		endtime=slapi_current_utc_time() + cb->max_idle_time;
+	}
 
 	/*
 	 * Call the backend preoperation plugins
diff --git a/ldap/servers/plugins/chainingdb/cb_modrdn.c b/ldap/servers/plugins/chainingdb/cb_modrdn.c
index 00c598c..912104b 100644
--- a/ldap/servers/plugins/chainingdb/cb_modrdn.c
+++ b/ldap/servers/plugins/chainingdb/cb_modrdn.c
@@ -128,8 +128,9 @@ chaining_back_modrdn ( Slapi_PBlock *pb )
 	}
 
 	/* heart-beat management */
-	if (cb->max_idle_time>0)
-		endtime=current_time() + cb->max_idle_time;
+	if (cb->max_idle_time>0) {
+		endtime=slapi_current_utc_time() + cb->max_idle_time;
+	}
 
 	/*
 	 * Call the backend preoperation plugins
